---
image: 'google/cloud-sdk:495.0.0-alpine'

stages:
  - test
  - update

.common:
  id_tokens:
    VAULT_ID_TOKEN:
      aud: https://vault.gitlab.net
  secrets:
    GCE_KEY:
      file: true
      vault: ${VAULT_SECRETS_PATH}/shared/google/service_account_key@ci
    SLACK_WEBHOOK_URL:
      file: false
      vault: ${VAULT_SECRETS_PATH}/shared/slack/webhook_url@ci
    OTHER_VAULT_PATHS:
      file: false
      vault: ${VAULT_SECRETS_PATH}/shared/paths/other_vault_paths@ci
  before_script:
    - apk add -U ruby ruby-json ruby-bundler gzip
    - bundle install
    - gcloud auth activate-service-account --key-file="${GCE_KEY}"

test:
  extends: .common
  stage: test
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
  variables:
    ENVIRONMENTS: "pre,ops,gstg,release"
    DRY_RUN: 1
  script:
    - bundle exec ruby main.rb

update:
  extends: .common
  stage: update
  environment:
    name: certificates-updater
  variables:
    SLACK_CHANNEL: "#production"
    USE_COMPRESSION: "true"
  secrets:
    SSLMATE_API_KEY:
      file: false
      vault: ${VAULT_SECRETS_PATH}/protected/shared/sslmate/api_key@ci
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $CI_PIPELINE_SOURCE == "schedule"
      when: on_success
  script:
    - bundle exec ruby main.rb
